package com.gxzc.zen.api.sys.common

import com.gxzc.zen.common.util.common.TreeNode

/**
 * 字典树
 * @author NorthLan
 * @date 2018/4/28
 * @url https://noahlan.com
 */
open class DictTree : TreeNode() {
    /**
     * 字典码
     */
    var code: String? = null
    /**
     * 字典值
     */
    var value: String? = null
    /**
     * 标签（中文名）
     */
    var label: String? = null
    /**
     * 类型（1.目录 2.字典)
     */
    var type: Int? = null

    override fun equals(other: Any?): Boolean {
        return if (other is DictTree) {
            other.code == this.code && other.type == this.type
        } else {
            super.equals(other)
        }
    }

    override fun hashCode(): Int {
        var result = super.hashCode()
        result = 31 * result + (code?.hashCode() ?: 0)
        result = 31 * result + (value?.hashCode() ?: 0)
        result = 31 * result + (label?.hashCode() ?: 0)
        result = 31 * result + (type ?: 0)
        return result
    }
}