package com.gxzc.zen.api.sys.service

import com.gxzc.zen.api.sys.model.SysRole
import com.gxzc.zen.umps.common.ZenPermission
import org.apache.shiro.session.Session

/**
 * <p>
 * 权限 服务类
 * </p>
 *
 * @author NorthLan
 * @since 2018-02-06
 */
interface ISysPermissionService {

    /**
     * 获取系统所有权限列表并存入 {code 系统缓存}
     */
    fun getAllSysPermission(): MutableList<ZenPermission>

    /**
     * 获取用户主体拥有的权限列表
     * 若session缓存中没有 则从数据库中取出
     */
    fun getSubjectPermission(): MutableList<ZenPermission>

    /**
     * 获取用户主体拥有的角色列表
     * 若session缓存中没有 则从数据库中取出
     */
    fun getSubjectRoles(session: Session): MutableList<SysRole>

    /**
     * 更新系统权限缓存
     */
    fun updateAllSysPermission()

    /**
     * 更新用户主体权限
     */
    fun updateSubjectPermissionByAccount(account: String)
}
