package com.gxzc.zen.api.sys.service

import com.gxzc.zen.api.sys.model.SysResource
import com.gxzc.zen.common.base.BaseService

/**
 * <p>
 * 资源表 服务类
 * </p>
 *
 * @author NorthLan
 * @since 2018-04-28
 */
interface ISysResourceService : BaseService<SysResource> {
    /**
     * 通过role id 列表获取 resource
     */
    fun getResourcesByRoleIds(roleIds: List<Long>): MutableList<SysResource>

    fun getResourcesByMenuId(menuId: Long): MutableList<SysResource>

    fun insertResource(menuId: Long, sysResource: SysResource): SysResource

    fun updateResource(sysResource: SysResource): SysResource

    fun deleteResourceById(id: Long)

    fun deleteResourcesByMenuId(menuId: Long)
}
